Index: devicestate.c
===================================================================
--- devicestate.c	(revision 43635)
+++ devicestate.c	(working copy)
@@ -73,7 +73,16 @@
 /*--- devstate2str: Find devicestate as text message for output */
 const char *devstate2str(int devstate) 
 {
-	return devstatestring[devstate];
+	int elements;
+
+	elements = (sizeof(devstatestring) /  sizeof(devstatestring[0]));
+	
+	if (devstate > elements || devstate < 0) {
+		ast_log(LOG_WARNING,"Invalid device state returning unknown.");
+		return devstatestring[0];
+	}
+	
+ 	return devstatestring[devstate];
 }
 
 /*--- ast_parse_device_state: Find out if device is active in a call or not */
